import { login, logout, getInfo } from '@/api/login'
import { getToken, setToken, removeToken } from '@/utils/auth'
import methods from "@/utils/methodsTool";
import { encrypt } from '@/utils/jsencrypt'

const user = {
  state: {
    token: getToken(),
    name: '',
    avatar: '',
    roles: [],
    permissions: [],
    userId: ''
  },

  mutations: {
    SET_TOKEN: (state, token) => {
      state.token = token
    },
    SET_NAME: (state, name) => {
      state.name = name
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions
    },
    SET_USERID: (state, userId) => {
      state.userId = userId
    },
    set_companyName(state, data) {
      state.companyName = data || ''
      document.title = data || ''
    },
  },

  actions: {
    // 登录
    Login({ commit }, userInfo) {
      const username = userInfo.username.trim()
      const password = encrypt(userInfo.password)
      // const password = userInfo.password
      const code = userInfo.code
      const uuid = userInfo.uuid
      const phonenumber = userInfo.phonenumber
      const smsCode = userInfo.smsCode
      return new Promise((resolve, reject) => {
        login(username, password, code, uuid, phonenumber, smsCode).then(res => {
          setToken(res.token)
          commit('SET_TOKEN', res.token)
          sessionStorage.TenantId = res.TenantId || methods.getQueryVariable('TenantId')
          sessionStorage.companyId = res.companyId
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 获取用户信息
    GetInfo({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo().then(result => {
          const res = result.data
          const user = res.user
          const avatar = user.avatar == "" ? require("@/assets/images/profile.jpg") : methods.getUrl() + user.avatar;
          if (res.roles && res.roles.length > 0) { // 验证返回的roles是否是一个非空数组
            commit('SET_ROLES', res.roles)
            commit('SET_PERMISSIONS', res.permissions)
          } else {
            commit('SET_ROLES', ['ROLE_DEFAULT'])
          }
          commit('SET_NAME', user.userName)
          commit('SET_AVATAR', avatar)
          commit('SET_USERID', user.userId)
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 获取企业id
    findTenantId({
      commit
    }) {
      return new Promise(resolve => {
        var urlReg = /[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+\.?/;
        var urls = location.origin.includes("localhost") ? '' : urlReg.exec(location.origin)[0];
        if (location.origin.includes("192.168.1") || location.origin.includes("localhost") || location.origin.includes("120.79.166.78")) {
          urls = "120.79.166.78:19012"
          // urls = "120.79.166.78:1901"
        }
        api.commonfreefindTenantId({ hostAdmin: urls })
          .then(function (res) {
            if (res.code === 200) {
              sessionStorage.TenantId = res.data
            } else {
              if (methods.getQueryVariable('TenantId')) {
                sessionStorage.TenantId = methods.getQueryVariable('TenantId')
              } else {
                sessionStorage.removeItem('TenantId')
              }
            }
            resolve()
          })
          .catch(function (error) {
            if (methods.getQueryVariable('TenantId')) {
              sessionStorage.TenantId = methods.getQueryVariable('TenantId')
            } else {
              sessionStorage.removeItem('TenantId')
            }
            resolve()
          });
      })
    },
    // 获取企业名字
    footerData({
      commit
    }) {
      return new Promise(resolve => {
        api.commonfreeconfig()
          .then(function (response) {
            commit('set_companyName', response.data.companyName)
            resolve()
          })
          .catch(function (error) {
            commit('set_companyName', '')
            resolve()
          });
      })
    },
    // 退出系统
    LogOut({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token).then(() => {
          commit('SET_TOKEN', '')
          commit('SET_ROLES', [])
          commit('SET_PERMISSIONS', [])
          removeToken()
          resolve()
          sessionStorage.removeItem('TenantId')
          sessionStorage.removeItem('companyId')
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 前端 登出
    FedLogOut({ commit }) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '')
        removeToken()
        resolve()
      })
    }
  }
}

export default user
